# Configurable Chart Collection (C3)

The [**Configurable Chart Collection**](http://drarmstr.github.io/c3/) is a JavaScript library for data visualization in HTML5 built using [D3](http://d3js.org).

### Notable visulizations include:

* [Line / Area Graphs](http://drarmstr.github.io/c3/examples/#plot_zoom)
* [Bar Charts](http://drarmstr.github.io/c3/examples/#stack)
* [Stacked Graphs](http://drarmstr.github.io/c3/examples/#stack)
* [Pie / Donut Charts](http://drarmstr.github.io/c3/examples/#pie)
* [Scatter Plots](http://drarmstr.github.io/c3/examples/#scatterplot)
* [Swimlanes](http://drarmstr.github.io/c3/examples/#swimlanes)
* [Flame Chart Timeline](http://drarmstr.github.io/c3/examples/#flamechart_sunburst)
* [Sunburst](http://drarmstr.github.io/c3/examples/#flamechart_sunburst)
* [Sankey Flow Graph](http://drarmstr.github.io/c3/examples/#sankey)
* [Butterfly _caller/callee_ Flow Graph](http://drarmstr.github.io/c3/examples/#butterfly)
* [Legends](http://drarmstr.github.io/c3/examples/#legend)
* [Data Tables](http://drarmstr.github.io/c3/examples/#table_searchable)

### Notable features include:

* [Declarative style API.](http://drarmstr.github.io/c3/api.html)
* [Flexibility with dataset organization.  Use your own structures and describe their shape via accessor functions.](http://drarmstr.github.io/c3/api.html#datasets)
* [Layering mechanism for composability of different data in the same chart.](http://drarmstr.github.io/c3/api.html#layers)
* [Compatible with animation for linked and dynamic datasets.](http://drarmstr.github.io/c3/api.html#selection_options)
* [Lots of styling options by exposing CSS directly.](http://drarmstr.github.io/c3/api.html#styling)
* [Extensible for custom user interaction by exposing DOM events.](http://drarmstr.github.io/c3/api.html#events)
* [Extensible with custom functionality.](http://drarmstr.github.io/c3/api.html#extensibility)
* Some visualizations contain built-in support for dealing with large datasets.
* Compatible with [Crossfilter](http://crossfilter.github.io/crossfilter/) ([_example_](http://drarmstr.github.io/c3/examples/#worldbank))

## [Examples](http://drarmstr.github.io/c3/examples/)
View example charts and visualizations with complete annotated sources.

## [Documentation](http://drarmstr.github.io/c3/)

#### [API Overview](http://drarmstr.github.io/c3/api.html)

#### [API Reference](http://drarmstr.github.io/c3/doc/)
