﻿// Generated by IcedCoffeeScript 108.0.11
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __slice = [].slice;

  c3.Plot.Layer = (function() {
    Layer.version = 0.1;

    c3.Layer = Layer;

    Layer.prototype.type = 'layer';

    Layer._next_uid = 0;

    Layer.prototype.data = void 0;

    Layer.prototype.name = void 0;

    Layer.prototype["class"] = void 0;

    Layer.prototype.static_data = false;

    Layer.prototype.h = void 0;

    Layer.prototype.v = void 0;

    Layer.prototype.x = void 0;

    Layer.prototype.y = void 0;

    Layer.prototype.options = void 0;

    Layer.prototype.handlers = void 0;

    function Layer(opt) {
      this.max_y = __bind(this.max_y, this);
      this.min_y = __bind(this.min_y, this);
      this.max_x = __bind(this.max_x, this);
      this.min_x = __bind(this.min_x, this);
      this.scale = __bind(this.scale, this);
      this.redraw = __bind(this.redraw, this);
      this.zoom = __bind(this.zoom, this);
      this.style = __bind(this.style, this);
      this.draw = __bind(this.draw, this);
      this.update = __bind(this.update, this);
      this.size = __bind(this.size, this);
      this.init = __bind(this.init, this);
      c3.util.extend(this, new c3.Dispatch);
      c3.util.extend(this, opt);
      this.uid = c3.Plot.Layer._next_uid++;
    }

    Layer.prototype.init = function(chart, g) {
      var event, handler, prototype, _ref;
      this.chart = chart;
      this.g = g;
      this.trigger('render_start');
      if (this.data == null) {
        this.data = this.chart.data;
      }
      if (this.h == null) {
        this.h = this.chart.h;
      }
      if (this.v == null) {
        this.v = this.chart.v;
      }
      if (this.x == null) {
        this.x = this.chart.x;
      }
      if (this.y == null) {
        this.y = this.chart.y;
      }
      if (this["class"] != null) {
        this.g.classed(this["class"], true);
      }
      if (this.handlers != null) {
        _ref = this.handlers;
        for (event in _ref) {
          handler = _ref[event];
          this.on(event, handler);
        }
      }
      this.content = c3.select(this.g);
      prototype = Object.getPrototypeOf(this);
      while (prototype) {
        if (prototype.type != null) {
          this.g.classed(prototype.type, true);
        }
        prototype = Object.getPrototypeOf(prototype);
      }
      if (typeof this._init === "function") {
        this._init();
      }
      return this.trigger('render');
    };

    Layer.prototype.size = function(width, height) {
      this.width = width;
      this.height = height;
      this.trigger('resize_start');
      c3.d3.set_range(this.h, [0, this.width]);
      c3.d3.set_range(this.v, [this.height, 0]);
      if (typeof this._size === "function") {
        this._size();
      }
      return this.trigger('resize');
    };

    Layer.prototype.update = function(origin) {
      if (this.chart == null) {
        throw Error("Attempt to redraw uninitialized plot layer, please use render() when modifying set of layers.");
      }
      this.trigger('redraw_start', origin);
      return typeof this._update === "function" ? this._update(origin) : void 0;
    };

    Layer.prototype.draw = function(origin) {
      if (!(this.static_data && origin === 'redraw')) {
        if (origin === 'resize') {
          this.trigger('redraw_start', origin);
        }
        if (typeof this._draw === "function") {
          this._draw(origin);
        }
        return this.trigger('redraw', origin);
      }
    };

    Layer.prototype.style = function(style_new) {
      this.trigger('restyle_start', style_new);
      if (typeof this._style === "function") {
        this._style(style_new);
      }
      this.trigger('restyle', style_new);
      if (!this.rendered) {
        this.trigger('rendered');
      }
      return this;
    };

    Layer.prototype.zoom = function() {
      if (typeof this.draw === "function") {
        this.draw('zoom');
      }
      return typeof this.style === "function" ? this.style(true) : void 0;
    };

    Layer.prototype.redraw = function(origin) {
      if (origin == null) {
        origin = 'redraw';
      }
      this.update(origin);
      this.draw(origin);
      this.style(true);
      return this;
    };

    Layer.prototype.restyle = Layer.prototype.style;

    Layer.prototype.scale = function() {
      var h_domain, refresh, v_domain;
      refresh = false;
      if (this.h_domain != null) {
        if (this.h === this.chart.h) {
          throw Error("Layer cannot scale shared h scale, please define just h or both h and h_domain for layers");
        }
        h_domain = typeof this.h_domain === 'function' ? this.h_domain.call(this) : this.h_domain;
        if (h_domain[0] === 'auto') {
          h_domain[0] = this.min_x();
        }
        if (h_domain[1] === 'auto') {
          h_domain[1] = this.max_x();
        }
        if (h_domain[0] !== this.h.domain()[0] || h_domain[1] !== this.h.domain()[1]) {
          this.h.domain(h_domain);
          refresh = true;
        }
      }
      if (this.v_domain != null) {
        if (this.v === this.chart.v) {
          throw Error("Layer cannot scale shared v scale, please define just v or both v and v_domain for layers");
        }
        v_domain = typeof this.v_domain === 'function' ? this.v_domain.call(this) : this.v_domain;
        if (v_domain[0] === 'auto') {
          v_domain[0] = this.min_y();
        }
        if (v_domain[1] === 'auto') {
          v_domain[1] = this.max_y();
        }
        if (v_domain[0] !== this.v.domain()[0] || v_domain[1] !== this.v.domain()[1]) {
          this.v.domain(v_domain);
          refresh = true;
        }
      }
      return refresh;
    };

    Layer.prototype.min_x = function() {
      return d3.min(this.data, this.x);
    };

    Layer.prototype.max_x = function() {
      return d3.max(this.data, this.x);
    };

    Layer.prototype.min_y = function() {
      return d3.min(this.data, this.y);
    };

    Layer.prototype.max_y = function() {
      return d3.max(this.data, this.y);
    };

    return Layer;

  })();

  c3.Plot.Layer.Stackable = (function(_super) {
    __extends(Stackable, _super);

    function Stackable() {
      this.max_y = __bind(this.max_y, this);
      this.min_y = __bind(this.min_y, this);
      this.max_x = __bind(this.max_x, this);
      this.min_x = __bind(this.min_x, this);
      this._style = __bind(this._style, this);
      this._update = __bind(this._update, this);
      this._stack = __bind(this._stack, this);
      return Stackable.__super__.constructor.apply(this, arguments);
    }

    Stackable.version = 0.2;

    Stackable.prototype.type = 'stackable';

    Stackable.prototype.stack_options = void 0;

    Stackable.prototype.stacks = void 0;

    Stackable.prototype.safe = true;

    Stackable.prototype._stack = function() {
      var add_value, datum, i, k, key, layer_h, stack, stack_h, stack_map, stacker, undef, v, x_values, x_values_set, _base, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _len5, _len6, _len7, _len8, _len9, _m, _n, _o, _p, _q, _r, _ref, _ref1, _ref10, _ref11, _ref12, _ref13, _ref14, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
      if (this.stack_options || (this.stacks != null)) {
        if (this.stacks == null) {
          this.stacks = [];
        }
        x_values_set = {};
        add_value = (function(_this) {
          return function(stack, datum, i) {
            var x, y, _ref;
            x = _this.x(datum, i);
            x_values_set[x] = x;
            stack.y = (function() {
              var _ref1;
              if ((_ref = (_ref1 = stack.y) != null ? _ref1 : this.y) != null) {
                return _ref;
              } else {
                throw Error("Y accessor must be defined in stack, layer, or chart");
              }
            }).call(_this);
            y = stack.y(datum, i, stack);
            return stack.values.push({
              x: x,
              y: y,
              datum: datum
            });
          };
        })(this);
        _ref = this.stacks;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          stack = _ref[_i];
          if (stack.name == null) {
            stack.name = (_ref1 = this.stack_options) != null ? typeof _ref1.name === "function" ? _ref1.name(stack.key) : void 0 : void 0;
          }
          stack.values = [];
          if (stack.data != null) {
            _ref2 = stack.data;
            for (i = _j = 0, _len1 = _ref2.length; _j < _len1; i = ++_j) {
              datum = _ref2[i];
              add_value(stack, datum, i);
            }
          }
        }
        if (this.current_data.length) {
          if (((_ref3 = this.stack_options) != null ? _ref3.key : void 0) != null) {
            stack_map = {};
            _ref4 = this.stacks;
            for (_k = 0, _len2 = _ref4.length; _k < _len2; _k++) {
              stack = _ref4[_k];
              if (stack_map[stack.key] != null) {
                throw Error("Stacks provided with duplicate keys: " + stack.key);
              }
              stack_map[stack.key] = stack;
            }
            _ref5 = this.current_data;
            for (i = _l = 0, _len3 = _ref5.length; _l < _len3; i = ++_l) {
              datum = _ref5[i];
              key = this.stack_options.key(datum);
              if (stack_map[key] != null) {
                stack = stack_map[key];
              } else {
                this.stacks.push(stack = stack_map[key] = {
                  key: key,
                  name: typeof (_base = this.stack_options).name === "function" ? _base.name(key) : void 0,
                  current_data: [],
                  values: []
                });
              }
              add_value(stack, datum, i);
            }
          } else if (this.stacks != null) {
            _ref6 = this.stacks;
            for (_m = 0, _len4 = _ref6.length; _m < _len4; _m++) {
              stack = _ref6[_m];
              _ref7 = this.current_data;
              for (i = _n = 0, _len5 = _ref7.length; _n < _len5; i = ++_n) {
                datum = _ref7[i];
                add_value(stack, datum, i);
              }
            }
          } else {
            throw Error("Either stacks or stack_options.key must be defined to create the set of stacks.");
          }
        }
        if (this.safe) {
          if (this.h.range()[0] === this.h.range()[1]) {
            this.h.range([0, 1]);
          }
          x_values = c3.array.sort_up((function() {
            var _results;
            _results = [];
            for (k in x_values_set) {
              v = x_values_set[k];
              _results.push(v);
            }
            return _results;
          })(), this.h);
          _ref8 = this.stacks;
          for (_o = 0, _len6 = _ref8.length; _o < _len6; _o++) {
            stack = _ref8[_o];
            c3.array.sort_up(stack.values, (function(_this) {
              return function(v) {
                return _this.h(v.x);
              };
            })(this));
          }
          i = 0;
          while (i < x_values.length) {
            undef = 0;
            _ref9 = this.stacks;
            for (_p = 0, _len7 = _ref9.length; _p < _len7; _p++) {
              stack = _ref9[_p];
              stack_h = this.h((_ref10 = stack.values[i]) != null ? _ref10.x : void 0);
              layer_h = this.h(x_values[i]);
              if (stack_h !== layer_h) {
                if (stack_h < layer_h) {
                  if (this.h.domain()[0] === this.h.domain()[1]) {
                    throw Error("Did you intend for an h scale with 0 domain?  Duplicate X values, invalid stacking, or bad h scale");
                  } else {
                    throw Error("Multiple data elements with the same x value in the same stack, or invalid stacking");
                  }
                }
                stack.values.splice(i, 0, {
                  x: x_values[i],
                  y: 0,
                  datum: null
                });
                undef++;
              } else if (stack.values[i].y == null) {
                stack.values[i].y = 0;
                undef++;
              }
            }
            if (undef === this.stacks.length) {
              _ref11 = this.stacks;
              for (_q = 0, _len8 = _ref11.length; _q < _len8; _q++) {
                stack = _ref11[_q];
                stack.values.splice(i, 1);
              }
              x_values.splice(i, 1);
              i--;
            }
            i++;
          }
        }
        _ref12 = this.stacks;
        for (_r = 0, _len9 = _ref12.length; _r < _len9; _r++) {
          stack = _ref12[_r];
          stack.current_data = stack.values.map(function(v) {
            return v.datum;
          });
        }
        stacker = d3.layout.stack().values(function(stack) {
          return stack.values;
        });
        if (((_ref13 = this.stack_options) != null ? _ref13.offset : void 0) != null) {
          stacker.offset(this.stack_options.offset);
        }
        if (((_ref14 = this.stack_options) != null ? _ref14.order : void 0) != null) {
          stacker.order(this.stack_options.order);
        }
        return stacker(this.stacks);
      }
    };

    Stackable.prototype._update = function() {
      var d, i, v, values, _ref, _ref1, _ref2, _ref3;
      this.current_data = !this.safe ? this.data : this.data != null ? (this.y != null) && (this.stacks == null) && (this.stack_options == null) ? (values = (function() {
        var _i, _len, _ref, _results;
        _ref = this.data;
        _results = [];
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          d = _ref[i];
          _results.push({
            x: this.x(d, i),
            y: this.y(d, i),
            datum: d
          });
        }
        return _results;
      }).call(this), c3.array.sort_up(values, (function(_this) {
        return function(v) {
          return _this.h(v.x);
        };
      })(this)), (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = values.length; _i < _len; _i++) {
          v = values[_i];
          if ((v.x != null) && (v.y != null)) {
            _results.push(v.datum);
          }
        }
        return _results;
      })()) : (values = (function() {
        var _i, _len, _ref, _results;
        _ref = this.data;
        _results = [];
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          d = _ref[i];
          _results.push({
            x: this.x(d, i),
            datum: d
          });
        }
        return _results;
      }).call(this), (this.stacks != null) || (this.stack_options != null) ? c3.array.sort_up(values, (function(_this) {
        return function(v) {
          return _this.h(v.x);
        };
      })(this)) : void 0, (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = values.length; _i < _len; _i++) {
          v = values[_i];
          if (v.x != null) {
            _results.push(v.datum);
          }
        }
        return _results;
      })()) : void 0;
      this._stack();
      return this.groups = this.content.select('g.stack').bind((_ref1 = this.stacks) != null ? _ref1 : [null], ((_ref2 = this.stacks) != null ? (_ref3 = _ref2[0]) != null ? _ref3.key : void 0 : void 0) == null ? null : function(stack) {
        return stack.key;
      }).options(this.stack_options, (((_ref = this.stacks) != null ? _ref.some(function(stack) {
        return stack.options != null;
      }) : void 0) ? function(stack) {
        return stack.options;
      } : void 0)).update();
    };

    Stackable.prototype._style = function(style_new) {
      var _ref;
      return (_ref = this.groups) != null ? _ref.style(style_new) : void 0;
    };

    Stackable.prototype.min_x = function() {
      var _ref;
      if (this.stacks == null) {
        return Stackable.__super__.min_x.apply(this, arguments);
      } else {
        return d3.min((_ref = this.stacks[0]) != null ? _ref.values : void 0, function(v) {
          return v.x;
        });
      }
    };

    Stackable.prototype.max_x = function() {
      var _ref;
      if (this.stacks == null) {
        return Stackable.__super__.max_x.apply(this, arguments);
      } else {
        return d3.max((_ref = this.stacks[0]) != null ? _ref.values : void 0, function(v) {
          return v.x;
        });
      }
    };

    Stackable.prototype.min_y = function() {
      if (this.stacks == null) {
        return Stackable.__super__.min_y.apply(this, arguments);
      } else {
        return 0;
      }
    };

    Stackable.prototype.max_y = function() {
      var i;
      if (this.stacks == null) {
        return Stackable.__super__.max_y.apply(this, arguments);
      } else {
        return d3.max((function() {
          var _i, _ref, _ref1, _results;
          _results = [];
          for (i = _i = 0, _ref = ((_ref1 = this.stacks[0]) != null ? _ref1.values.length : void 0) - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
            _results.push(d3.sum(this.stacks, function(s) {
              return s.values[i].y;
            }));
          }
          return _results;
        }).call(this));
      }
    };

    return Stackable;

  })(c3.Plot.Layer);

  c3.Plot.Layer.Stackable.Stack = (function() {
    Stack.version = 0.1;

    Stack.prototype.key = void 0;

    Stack.prototype.y = void 0;

    Stack.prototype.data = void 0;

    Stack.prototype.name = void 0;

    Stack.prototype.options = void 0;

    function Stack(opt) {
      c3.util.extend(this, opt);
    }

    return Stack;

  })();

  c3.Plot.Layer.Path = (function(_super) {
    __extends(Path, _super);

    function Path() {
      this.max_x = __bind(this.max_x, this);
      this.min_x = __bind(this.min_x, this);
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      this._update = __bind(this._update, this);
      this._init = __bind(this._init, this);
      return Path.__super__.constructor.apply(this, arguments);
    }

    Path.version = 0.2;

    Path.prototype.type = 'path';

    Path.prototype.path_generator_factory = void 0;

    Path.prototype.interpolate = void 0;

    Path.prototype.tension = void 0;

    Path.prototype.defined = void 0;

    Path.prototype.r = void 0;

    Path.prototype.a = void 0;

    Path.prototype.path_options = void 0;

    Path.prototype.circle_options = void 0;

    Path.prototype.label_options = void 0;

    Path.prototype._init = function() {
      if (this.path_generator_factory == null) {
        throw Error("path_generator_factory must be defined for a path layer");
      }
      return this.path_generator = this.path_generator_factory();
    };

    Path.prototype._update = function(origin) {
      if (origin !== 'zoom') {
        Path.__super__._update.apply(this, arguments);
        this.paths = this.groups.inherit('path.scaled').options(this.path_options);
        if ((this.r != null) || (this.a != null)) {
          this.circles = this.groups.select('circle').options(this.circle_options).animate(origin === 'redraw').bind(this.stacks != null ? function(stack) {
            return stack.current_data;
          } : this.current_data).update();
        }
        if (this.label_options != null) {
          return this.labels = this.groups.select('text').options(this.label_options).animate(origin === 'redraw').bind(this.stacks != null ? function(stack) {
            return stack.current_data;
          } : this.current_data).update();
        }
      }
    };

    Path.prototype._draw = function(origin) {
      var orig_h, _ref, _ref1, _ref2;
      if (origin !== 'zoom') {
        if (this.interpolate != null) {
          this.path_generator.interpolate(this.interpolate);
        }
        if (this.tension != null) {
          this.path_generator.tension(this.tension);
        }
        if (this.defined != null) {
          this.path_generator.defined(this.defined);
        }
        orig_h = (_ref = this.chart.orig_h) != null ? _ref : this.h;
        this.paths.animate(origin === 'redraw').position({
          d: this.stacks != null ? (function(_this) {
            return function(stack, stack_idx) {
              var _base;
              if (typeof (_base = _this.path_generator.x(function(d, i) {
                return orig_h(stack.values[i].x);
              }).y(function(d, i) {
                return _this.v(stack.values[i].y0 + stack.values[i].y);
              })).y0 === "function") {
                _base.y0((_this.baseline != null) && !stack_idx ? function(d, i) {
                  return _this.v(c3.functor(_this.baseline)(d, i));
                } : function(d, i) {
                  return _this.v(stack.values[i].y0);
                });
              }
              return _this.path_generator(stack.current_data);
            };
          })(this) : (function(_this) {
            return function() {
              var _base;
              if (typeof (_base = _this.path_generator.x(function(d, i) {
                return orig_h(_this.x(d, i));
              }).y(function(d, i) {
                return _this.v(_this.y(d, i));
              })).y0 === "function") {
                _base.y0(_this.baseline != null ? function(d, i) {
                  return _this.v(c3.functor(_this.baseline)(d, i));
                } : _this.height);
              }
              return _this.path_generator(_this.current_data);
            };
          })(this)
        });
      }
      if ((_ref1 = this.circles) != null) {
        _ref1.animate(origin === 'redraw').position({
          cx: (function(_this) {
            return function(d, i, s) {
              return _this.h(_this.x(d, i, s));
            };
          })(this),
          cy: this.stacks != null ? (function(_this) {
            return function(d, i, s) {
              var values;
              values = _this.stacks[s].values[i];
              return _this.v(values.y + values.y0);
            };
          })(this) : (function(_this) {
            return function(d, i) {
              return _this.v(_this.y(d, i));
            };
          })(this),
          r: this.a == null ? this.r : typeof this.a === 'function' ? (function(_this) {
            return function(d, i, s) {
              return Math.sqrt(_this.a(d, i, s) / Math.PI);
            };
          })(this) : Math.sqrt(this.a / Math.PI)
        });
      }
      return (_ref2 = this.labels) != null ? _ref2.animate(origin === 'redraw').position({
        transform: (function(_this) {
          return function(d, i, s) {
            return 'translate(' + (_this.h(_this.x(d, i, s))) + ',' + (_this.v(_this.y(d, i, s))) + ')';
          };
        })(this)
      }) : void 0;
    };

    Path.prototype._style = function(style_new) {
      var _ref, _ref1;
      Path.__super__._style.apply(this, arguments);
      if ((_ref = this.circles) != null) {
        _ref.style(style_new);
      }
      return (_ref1 = this.labels) != null ? _ref1.style(style_new) : void 0;
    };

    Path.prototype.min_x = function() {
      var _ref, _ref1;
      if (this.stacks == null) {
        if (this.data.length) {
          return this.x(this.data[0]);
        }
      } else {
        return (_ref = this.stacks[0]) != null ? (_ref1 = _ref.values[0]) != null ? _ref1.x : void 0 : void 0;
      }
    };

    Path.prototype.max_x = function() {
      var _ref, _ref1;
      if (this.stacks == null) {
        if (this.data.length) {
          return this.x(this.data.slice(-1)[0]);
        }
      } else {
        return (_ref = this.stacks[0]) != null ? (_ref1 = _ref.values.slice(-1)[0]) != null ? _ref1.x : void 0 : void 0;
      }
    };

    return Path;

  })(c3.Plot.Layer.Stackable);

  c3.Plot.Layer.Line = (function(_super) {
    __extends(Line, _super);

    function Line() {
      return Line.__super__.constructor.apply(this, arguments);
    }

    Line.prototype.type = 'line';

    Line.prototype.path_generator_factory = d3.svg.line;

    return Line;

  })(c3.Plot.Layer.Path);

  c3.Plot.Layer.Area = (function(_super) {
    __extends(Area, _super);

    function Area() {
      return Area.__super__.constructor.apply(this, arguments);
    }

    Area.prototype.type = 'area';

    Area.prototype.path_generator_factory = d3.svg.area;

    Area.prototype.baseline = void 0;

    return Area;

  })(c3.Plot.Layer.Path);

  c3.Plot.Layer.Bar = (function(_super) {
    __extends(Bar, _super);

    function Bar() {
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      this._update = __bind(this._update, this);
      return Bar.__super__.constructor.apply(this, arguments);
    }

    Bar.version = 0.2;

    Bar.prototype.type = 'bar';

    Bar.prototype.key = void 0;

    Bar.prototype.bar_width = "50%";

    Bar.prototype.rect_options = void 0;

    Bar.prototype._update = function() {
      Bar.__super__._update.apply(this, arguments);
      return this.rects = this.groups.select('rect').options(this.rect_options).animate('origin is redraw').bind((this.stacks != null ? (function(stack) {
        return stack.current_data;
      }) : this.current_data), this.key).update();
    };

    Bar.prototype._draw = function(origin) {
      var bar_ratio, bar_shift, bar_width, baseline, height, x, y, _base, _base1;
      baseline = this.v(0);
      if (typeof this.bar_width === 'function') {
        bar_width = this.bar_width;
        bar_shift = function() {
          return bar_width.apply(null, arguments) / 2;
        };
      } else {
        bar_width = +this.bar_width;
        if (!isNaN(bar_width)) {
          if (typeof (_base = this.h).rangeBands === "function") {
            _base.rangeBands(this.h.rangeExtent(), 1, 0.5);
          }
          bar_shift = bar_width / 2;
        } else {
          if ((typeof (_base1 = this.bar_width).charAt === "function" ? _base1.charAt(this.bar_width.length - 1) : void 0) === '%') {
            bar_ratio = +this.bar_width.slice(0, -1) / 100;
            if (isNaN(bar_ratio)) {
              throw "Invalid bar_width percentage " + this.bar_width.slice(0, -1);
            }
            if (this.h.rangeBands != null) {
              this.h.rangeBands(this.h.rangeExtent(), 1 - bar_ratio, 1 - bar_ratio);
              bar_width = this.h.rangeBand();
              bar_shift = 0;
            } else {
              bar_width = this.stacks != null ? (function(_this) {
                return function(d, i, j) {
                  var left, mid, right, values, width, _ref, _ref1;
                  values = _this.stacks[j].values;
                  mid = _this.h(values[i].x);
                  left = _this.h(!i ? ((_ref = _this.chart.orig_h) != null ? _ref : _this.h).domain()[0] : values[i - 1].x);
                  right = _this.h(i === values.length - 1 ? ((_ref1 = _this.chart.orig_h) != null ? _ref1 : _this.h).domain()[1] : values[i + 1].x);
                  width = Math.min(mid - left, right - mid) * bar_ratio;
                  if (width >= 0) {
                    return width;
                  } else {
                    return 0;
                  }
                };
              })(this) : (function(_this) {
                return function(d, i) {
                  var left, mid, right, width, _ref, _ref1;
                  mid = _this.h(_this.x(d, i));
                  left = _this.h(!i ? ((_ref = _this.chart.orig_h) != null ? _ref : _this.h).domain()[0] : _this.x(_this.current_data[i - 1], i - 1));
                  right = _this.h(i === _this.current_data.length - 1 ? ((_ref1 = _this.chart.orig_h) != null ? _ref1 : _this.h).domain()[1] : _this.x(_this.current_data[i + 1], i + 1));
                  width = Math.min(mid - left, right - mid) * bar_ratio;
                  if (width >= 0) {
                    return width;
                  } else {
                    return 0;
                  }
                };
              })(this);
              bar_shift = function() {
                return bar_width.apply(null, arguments) / 2;
              };
            }
          } else {
            throw "Invalid bar_width " + this.bar_width;
          }
        }
      }
      if (this.stacks != null) {
        x = (function(_this) {
          return function(d, i, j) {
            return _this.h(_this.stacks[j].values[i].x);
          };
        })(this);
        y = (function(_this) {
          return function(d, i, j) {
            return _this.v(_this.stacks[j].values[i].y0 + _this.stacks[j].values[i].y);
          };
        })(this);
        height = (function(_this) {
          return function(d, i, j) {
            return baseline - (_this.v(_this.stacks[j].values[i].y));
          };
        })(this);
      } else {
        x = (function(_this) {
          return function(d, i) {
            return _this.h(_this.x(d, i));
          };
        })(this);
        y = (function(_this) {
          return function(d, i) {
            y = _this.y(d, i);
            if (y > 0) {
              return _this.v(y);
            } else {
              return baseline;
            }
          };
        })(this);
        height = (function(_this) {
          return function(d, i) {
            return Math.abs(baseline - (_this.v(_this.y(d, i))));
          };
        })(this);
      }
      return this.rects.animate(origin === 'redraw').position({
        x: !bar_shift ? x : typeof bar_shift !== 'function' ? function() {
          return x.apply(null, arguments) - bar_shift;
        } : function() {
          return x.apply(null, arguments) - bar_shift.apply(null, arguments);
        },
        y: y,
        height: height,
        width: bar_width
      });
    };

    Bar.prototype._style = function(style_new) {
      Bar.__super__._style.apply(this, arguments);
      return this.rects.style(style_new);
    };

    return Bar;

  })(c3.Plot.Layer.Stackable);

  c3.Plot.Layer.Line.Straight = (function(_super) {
    __extends(Straight, _super);

    function Straight() {
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      this._update = __bind(this._update, this);
      this._size = __bind(this._size, this);
      this._init = __bind(this._init, this);
      return Straight.__super__.constructor.apply(this, arguments);
    }

    Straight.version = 0.1;

    Straight.prototype.type = 'straight';

    Straight.prototype.key = void 0;

    Straight.prototype.value = void 0;

    Straight.prototype.filter = void 0;

    Straight.prototype.draggable = false;

    Straight.prototype.vector_options = void 0;

    Straight.prototype.line_options = void 0;

    Straight.prototype.label_options = void 0;

    Straight.prototype._init = function() {
      var drag_value, self;
      if (this.value == null) {
        this.value = function(d) {
          return d;
        };
      }
      if (this.draggable) {
        self = this;
        this.dragger = d3.behavior.drag();
        drag_value = void 0;
        this.dragger.on('dragstart', (function(_this) {
          return function(d, i) {
            d3.event.sourceEvent.stopPropagation();
            return _this.trigger('dragstart', d, i);
          };
        })(this));
        this.dragger.on('drag', function(d, i) {
          var domain, _ref;
          domain = ((_ref = self.chart.orig_h) != null ? _ref : self.scale).domain();
          drag_value = Math.min(Math.max(self.scale.invert(d3.event.y), domain[0]), domain[1]);
          d3.select(this).attr('transform', 'translate(0,' + self.scale(drag_value) + ')');
          return self.trigger('drag', drag_value, d, i);
        });
        return this.dragger.on('dragend', (function(_this) {
          return function(d, i) {
            return _this.trigger('dragend', drag_value, d, i);
          };
        })(this));
      }
    };

    Straight.prototype._size = function() {
      var _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      if ((_ref = this.lines) != null) {
        if ((_ref1 = _ref.all) != null) {
          _ref1.attr('x2', this.line_length);
        }
      }
      if ((_ref2 = this.grab_lines) != null) {
        if ((_ref3 = _ref2.all) != null) {
          _ref3.attr('x2', this.line_length);
        }
      }
      return (_ref4 = this.labels) != null ? (_ref5 = _ref4.all) != null ? _ref5.attr('x', this.label_options.alignment === 'right' || this.label_options.alignment === 'top' ? this.width : 0) : void 0 : void 0;
    };

    Straight.prototype._update = function(origin) {
      var d, i, _base, _base1;
      this.current_data = this.filter != null ? (function() {
        var _i, _len, _ref, _results;
        _ref = this.data;
        _results = [];
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          d = _ref[i];
          if (this.filter(d, i)) {
            _results.push(d);
          }
        }
        return _results;
      }).call(this) : this.data;
      this.vectors = this.content.select('g.vector').options(this.vector_options).animate(origin === 'redraw').bind(this.current_data, this.key).update();
      this.lines = this.vectors.inherit('line').options(this.line_options).update();
      if (this.label_options != null) {
        if ((_base = this.label_options).dx == null) {
          _base.dx = '0.25em';
        }
        if ((_base1 = this.label_options).dy == null) {
          _base1.dy = '-0.25em';
        }
        this.labels = this.vectors.inherit('text').options(this.label_options).update();
      }
      if (this.draggable) {
        this.vectors["new"].call(this.dragger);
        return this.grab_lines = this.vectors.inherit('line.grab');
      }
    };

    Straight.prototype._draw = function(origin) {
      var far_labels, _ref;
      this.vectors.animate(origin === 'redraw').position({
        transform: (function(_this) {
          return function(d, i) {
            return 'translate(0,' + (_this.scale(_this.value(d, i))) + ')';
          };
        })(this)
      });
      this.lines["new"].attr('x2', this.line_length);
      if ((_ref = this.grab_lines) != null) {
        _ref["new"].attr('x2', this.line_length);
      }
      if (this.labels != null) {
        far_labels = this.label_options.alignment === 'right' || this.label_options.alignment === 'top';
        this.g.style('text-anchor', far_labels ? 'end' : 'start');
        return this.labels.position({
          dx: far_labels ? '-' + this.label_options.dx : this.label_options.dx,
          dy: this.label_options.dy,
          x: far_labels ? this.line_length : 0
        });
      }
    };

    Straight.prototype._style = function(style_new) {
      var _ref;
      this.g.classed('draggable', this.draggable);
      this.vectors.style(style_new);
      this.lines.style(style_new);
      return (_ref = this.labels) != null ? typeof _ref.style === "function" ? _ref.style(style_new) : void 0 : void 0;
    };

    return Straight;

  })(c3.Plot.Layer);

  c3.Plot.Layer.Line.Horizontal = (function(_super) {
    __extends(Horizontal, _super);

    function Horizontal() {
      this._size = __bind(this._size, this);
      this._init = __bind(this._init, this);
      return Horizontal.__super__.constructor.apply(this, arguments);
    }

    Horizontal.prototype.type = 'horizontal';

    Horizontal.prototype._init = function() {
      if (typeof label_options !== "undefined" && label_options !== null) {
        if (label_options.alignment == null) {
          label_options.alignment = 'left';
        }
      }
      Horizontal.__super__._init.apply(this, arguments);
      return this.scale = this.v;
    };

    Horizontal.prototype._size = function() {
      this.line_length = this.width;
      return Horizontal.__super__._size.apply(this, arguments);
    };

    return Horizontal;

  })(c3.Plot.Layer.Line.Straight);

  c3.Plot.Layer.Line.Vertical = (function(_super) {
    __extends(Vertical, _super);

    function Vertical() {
      this._size = __bind(this._size, this);
      this._init = __bind(this._init, this);
      return Vertical.__super__.constructor.apply(this, arguments);
    }

    Vertical.prototype.type = 'vertical';

    Vertical.prototype._init = function() {
      if (typeof label_options !== "undefined" && label_options !== null) {
        if (label_options.alignment == null) {
          label_options.alignment = 'top';
        }
      }
      Vertical.__super__._init.apply(this, arguments);
      return this.scale = this.h;
    };

    Vertical.prototype._size = function() {
      this.g.attr({
        transform: 'rotate(-90) translate(' + -this.height + ',0)'
      });
      this.line_length = this.height;
      return Vertical.__super__._size.apply(this, arguments);
    };

    return Vertical;

  })(c3.Plot.Layer.Line.Straight);

  c3.Plot.Layer.Region = (function(_super) {
    __extends(Region, _super);

    function Region() {
      return Region.__super__.constructor.apply(this, arguments);
    }

    Region.prototype.type = 'region';

    return Region;

  })(c3.Plot.Layer);

  c3.Plot.Layer.Scatter = (function(_super) {
    __extends(Scatter, _super);

    function Scatter() {
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      this._update = __bind(this._update, this);
      this._init = __bind(this._init, this);
      return Scatter.__super__.constructor.apply(this, arguments);
    }

    Scatter.version = 0.1;

    Scatter.prototype.type = 'scatter';

    Scatter.prototype.key = void 0;

    Scatter.prototype.value = void 0;

    Scatter.prototype.r = 1;

    Scatter.prototype.a = void 0;

    Scatter.prototype.safe = true;

    Scatter.prototype.filter = void 0;

    Scatter.prototype.limit_elements = void 0;

    Scatter.prototype.point_options = void 0;

    Scatter.prototype.circle_options = void 0;

    Scatter.prototype.label_options = void 0;

    Scatter.prototype._init = function() {
      if (this.x == null) {
        throw Error("x must be defined for a scatter plot layer");
      }
      if (this.y == null) {
        throw Error("y must be defined for a scatter plot layer");
      }
      if (this.h == null) {
        throw Error("h must be defined for a scatter plot layer");
      }
      if (this.v == null) {
        throw Error("v must be defined for a scatter plot layer");
      }
    };

    Scatter.prototype._update = function(origin) {
      var d, i;
      if (!this.data) {
        throw Error("Data must be defined for scatter layer.");
      }
      this.current_data = (this.filter != null) && (this.key != null) ? (function() {
        var _i, _len, _ref, _results;
        _ref = this.data;
        _results = [];
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          d = _ref[i];
          if (this.filter(d, i)) {
            _results.push(d);
          }
        }
        return _results;
      }).call(this) : this.data;
      if (this.safe) {
        this.current_data = (function() {
          var _i, _len, _ref, _results;
          _ref = this.current_data;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            d = _ref[_i];
            if ((this.x(d) != null) && (this.y(d) != null) && ((this.a == null) || typeof this.a !== 'function' || (this.a(d) != null)) && (typeof this.r !== 'function' || (this.r(d) != null))) {
              _results.push(d);
            }
          }
          return _results;
        }).call(this);
      }
      if (this.limit_elements != null) {
        if (this.value != null) {
          this.current_data = this.current_data.slice(0);
          c3.array.sort_up(this.current_data, (function(_this) {
            return function(d) {
              return -_this.value(d);
            };
          })(this));
          this.current_data = this.current_data.slice(0, +this.limit_elements + 1 || 9e9);
        } else {
          this.current_data = this.current_data.slice(0, +this.limit_elements + 1 || 9e9);
        }
      }
      this.points = this.content.select('g.point').options(this.point_options).animate(origin === 'redraw').bind(this.current_data, this.key).update();
      if ((this.filter != null) && (this.key == null)) {
        this.points.all.attr('display', (function(_this) {
          return function(d, i) {
            if (!_this.filter(d, i)) {
              return 'none';
            }
          };
        })(this));
      }
      this.circles = this.points.inherit('circle').options(this.circle_options).animate(origin === 'redraw').update();
      if (this.label_options != null) {
        return this.labels = this.points.inherit('text').options(this.label_options).update();
      }
    };

    Scatter.prototype._draw = function(origin) {
      this.points.animate(origin === 'redraw').position({
        transform: (function(_this) {
          return function(d, i) {
            return 'translate(' + (_this.h(_this.x(d, i))) + ',' + (_this.v(_this.y(d, i))) + ')';
          };
        })(this)
      });
      return this.circles.animate(origin === 'redraw').position({
        r: this.a == null ? this.r : typeof this.a === 'function' ? (function(_this) {
          return function(d, i) {
            return Math.sqrt(_this.a(d, i) / Math.PI);
          };
        })(this) : Math.sqrt(this.a / Math.PI)
      });
    };

    Scatter.prototype._style = function(style_new) {
      var _ref;
      this.points.style(style_new);
      this.circles.style(style_new);
      return (_ref = this.labels) != null ? _ref.style(style_new) : void 0;
    };

    return Scatter;

  })(c3.Plot.Layer);

  c3.Plot.Layer.Swimlane = (function(_super) {
    __extends(Swimlane, _super);

    function Swimlane() {
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      this._update = __bind(this._update, this);
      this._size = __bind(this._size, this);
      this._init = __bind(this._init, this);
      return Swimlane.__super__.constructor.apply(this, arguments);
    }

    Swimlane.prototype.type = 'swimlane';

    Swimlane.prototype.dy = void 0;

    Swimlane.prototype.hover = void 0;

    Swimlane.prototype.lane_options = void 0;

    Swimlane.prototype._init = function() {
      var anchor, layer, mousemove;
      if (this.lane_options != null) {
        this.lanes = this.content.select('rect.lane', ':first-child').options(this.lane_options);
      }
      if (this.hover != null) {
        anchor = d3.select(this.chart.anchor);
        this.tip = c3.select(anchor, 'div.c3.hover').singleton();
        layer = this;
        mousemove = function() {
          var hover_html, layerX, layerY, swimlane, x, _ref;
          _ref = d3.mouse(this), layerX = _ref[0], layerY = _ref[1];
          swimlane = Math.floor(layer._v.invert(layerY));
          swimlane = Math.min(swimlane, Math.max(layer.v.domain()[0], layer.v.domain()[1] - 1));
          x = layer.h.invert(layerX);
          hover_html = (c3.functor(layer.hover)).apply(null, __slice.call(layer._hover_datum(x, swimlane)).concat([swimlane]));
          if (!hover_html) {
            return layer.tip.all.style('display', 'none');
          } else {
            layer.tip.all.html(hover_html);
            return layer.tip.all.style({
              display: 'block',
              left: d3.event.clientX + 'px',
              top: d3.event.clientY + 'px'
            });
          }
        };
        this.chart.content.all.on('mouseleave.hover', (function(_this) {
          return function() {
            return layer.tip.all.style('display', 'none');
          };
        })(this));
        this.chart.content.all.on('mousedown.hover', (function(_this) {
          return function() {
            layer.tip.all.style('display', 'none');
            return _this.chart.content.all.on('mousemove.hover', null);
          };
        })(this));
        this.chart.content.all.on('mouseup.hover', (function(_this) {
          return function() {
            return _this.chart.content.all.on('mousemove.hover', mousemove);
          };
        })(this));
        this.chart.content.all.on('mouseenter.hover', (function(_this) {
          return function() {
            if (!d3.event.buttons) {
              return _this.chart.content.all.on('mousemove.hover', mousemove);
            }
          };
        })(this));
        return this.chart.content.all.on('mousemove.hover', mousemove);
      }
    };

    Swimlane.prototype._size = function() {
      if (this.y == null) {
        return this.dy = this.height;
      } else {
        return this.dy != null ? this.dy : this.dy = Math.round(this.height / (Math.abs(this.v.domain()[1] - this.v.domain()[0])));
      }
    };

    Swimlane.prototype._update = function() {
      var _i, _ref, _ref1, _ref2, _results;
      this.x = c3.functor(this.x);
      this.dx = c3.functor(this.dx);
      if ((_ref = this.lanes) != null) {
        _ref.bind((function() {
          _results = [];
          for (var _i = _ref1 = this.v.domain()[0], _ref2 = this.v.domain()[1]; _ref1 <= _ref2 ? _i < _ref2 : _i > _ref2; _ref1 <= _ref2 ? _i++ : _i--){ _results.push(_i); }
          return _results;
        }).apply(this)).update();
      }
      if (this.y != null) {
        return this.chart.size(null, this.dy * (Math.abs(this.v.domain()[1] - this.v.domain()[0])) + this.chart.margins.top + this.chart.margins.bottom);
      }
    };

    Swimlane.prototype._draw = function(origin) {
      var _ref;
      this._v = this.v.copy();
      c3.d3.set_range(this._v, [0, this.height]);
      if (origin === 'resize' || origin === 'render') {
        return (_ref = this.lanes) != null ? _ref.position({
          y: (function(_this) {
            return function(lane) {
              return _this._v(lane + (_this.invert_y ? 1 : 0));
            };
          })(this),
          width: this.chart.orig_h.range()[1],
          height: this.dy
        }) : void 0;
      }
    };

    Swimlane.prototype._style = function() {
      var _ref;
      return (_ref = this.lanes) != null ? _ref.style() : void 0;
    };

    return Swimlane;

  })(c3.Plot.Layer);

  c3.Plot.Layer.Swimlane.Segment = (function(_super) {
    var scaled;

    __extends(Segment, _super);

    function Segment() {
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      this._update = __bind(this._update, this);
      this._hover_datum = __bind(this._hover_datum, this);
      this._init = __bind(this._init, this);
      return Segment.__super__.constructor.apply(this, arguments);
    }

    Segment.version = 0.1;

    Segment.prototype.type = 'segment';

    Segment.prototype.dx = null;

    Segment.prototype.key = void 0;

    Segment.prototype.filter = void 0;

    Segment.prototype.value = void 0;

    Segment.prototype.limit_elements = void 0;

    Segment.prototype.rect_options = void 0;

    Segment.prototype.label_options = void 0;

    scaled = false;

    Segment.prototype._init = function() {
      var _ref;
      Segment.__super__._init.apply(this, arguments);
      this.g.classed('segment', true);
      if (scaled) {
        this.scaled_g = this.g.append('g').attr('class', 'scaled');
      }
      this.rects_group = c3.select((_ref = this.scaled_g) != null ? _ref : this.g, 'g.segments').singleton();
      if (this.label_options != null) {
        return this.labels_clip = c3.select(this.g, 'g.labels').singleton().select('svg');
      }
    };

    Segment.prototype._hover_datum = function(x, swimlane) {
      var datum, idx, right, _i, _len, _ref, _x;
      right = this.h.invert(this.h(x) + 1);
      _ref = this.current_data;
      for (idx = _i = 0, _len = _ref.length; _i < _len; idx = ++_i) {
        datum = _ref[idx];
        if (((this.y == null) || this.y(datum) === swimlane) && (_x = this.x(datum)) <= right && x <= _x + this.dx(datum)) {
          break;
        }
      }
      if (idx === this.current_data.length) {
        return [null, null];
      } else {
        return [datum, idx];
      }
    };

    Segment.prototype._update = function() {
      var d, i, _ref;
      Segment.__super__._update.apply(this, arguments);
      this.current_data = this.filter == null ? this.data : (function() {
        var _i, _len, _ref, _results;
        _ref = this.data;
        _results = [];
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          d = _ref[i];
          if (this.filter(d, i)) {
            _results.push(d);
          }
        }
        return _results;
      }).call(this);
      if (this.limit_elements != null) {
        if (this.filter == null) {
          this.current_data = this.current_data.slice(0);
        }
        return c3.array.sort_down(this.current_data, (_ref = this.value) != null ? _ref : this.dx);
      }
    };

    Segment.prototype._draw = function(origin) {
      var current_labels, data, datum, dx, h, half_pixel_width, left_edge, right_edge, self, x, zero_pos, _i, _len, _ref, _ref1, _ref2;
      Segment.__super__._draw.apply(this, arguments);
      _ref = this.h.domain(), left_edge = _ref[0], right_edge = _ref[1];
      half_pixel_width = (right_edge - left_edge) / ((this.h.range()[1] - this.h.range()[0]) || 1) / 2;
      data = [];
      _ref1 = this.current_data;
      for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
        datum = _ref1[_i];
        if (!((x = this.x(datum)) < right_edge && (x + (dx = this.dx(datum))) > left_edge)) {
          continue;
        }
        if (dx < half_pixel_width) {
          if (this.limit_elements != null) {
            break;
          } else {
            continue;
          }
        }
        data.push(datum);
        if (data.length === this.limit_elements) {
          break;
        }
      }
      this.rects = this.rects_group.select('rect.segment').options(this.rect_options).bind(data, this.key).update();
      h = this.scaled_g != null ? (_ref2 = this.chart.orig_h) != null ? _ref2 : this.h : this.h;
      zero_pos = h(0);
      (origin === 'resize' ? this.rects.all : this.rects["new"]).attr('height', this.dy);
      (!scaled || (this.key == null) || origin === 'resize' || (origin === 'redraw' && this instanceof c3.Plot.Layer.Swimlane.Flamechart) ? this.rects.all : this.rects["new"]).attr({
        x: (function(_this) {
          return function(d) {
            return h(_this.x(d));
          };
        })(this),
        width: (function(_this) {
          return function(d) {
            return (h(_this.dx(d))) - zero_pos;
          };
        })(this),
        y: this.y == null ? 0 : (function(_this) {
          return function(d) {
            return _this._v(_this.y(d));
          };
        })(this)
      });
      if (this.label_options != null) {
        zero_pos = this.h(0);
        current_labels = (function() {
          var _j, _len1, _results;
          _results = [];
          for (_j = 0, _len1 = data.length; _j < _len1; _j++) {
            datum = data[_j];
            if ((this.h(this.dx(datum))) - zero_pos > 50) {
              _results.push(datum);
            }
          }
          return _results;
        }).call(this);
        this.labels_clip.bind(current_labels, this.key);
        this.labels = this.labels_clip.inherit('text').options(this.label_options).update();
        (origin === 'resize' ? this.labels_clip.all : this.labels_clip["new"]).attr('height', this.dy);
        this.labels_clip.position({
          x: (function(_this) {
            return function(d) {
              return _this.h(_this.x(d));
            };
          })(this),
          y: this.y == null ? 0 : (function(_this) {
            return function(d, i) {
              return _this._v(_this.y(d, i));
            };
          })(this),
          width: (function(_this) {
            return function(d) {
              return (_this.h(_this.dx(d))) - zero_pos;
            };
          })(this)
        });
        self = this;
        (origin === 'resize' ? this.labels.all : this.labels["new"]).attr('y', self.dy / 2);
        this.labels.position({
          x: function(d) {
            var left, right;
            x = self.x(d);
            dx = self.dx(d);
            left = Math.max(x, self.h.domain()[0]);
            right = Math.min(x + dx, self.h.domain()[1]);
            return self.h((right - left) / 2 + (left - x)) - zero_pos;
          }
        });
      } else {
        c3.select(this.g, 'g.labels').all.remove();
      }
      if (origin === 'resize' && (!this.rects["new"].empty() || ((this.labels != null) && !this.labels["new"].empty()))) {
        return this._style(true);
      }
    };

    Segment.prototype._style = function(style_new) {
      var _ref;
      Segment.__super__._style.apply(this, arguments);
      this.rects.style(style_new);
      return (_ref = this.labels) != null ? _ref.style(style_new) : void 0;
    };

    return Segment;

  })(c3.Plot.Layer.Swimlane);

  c3.Plot.Layer.Swimlane.Flamechart = (function(_super) {
    __extends(Flamechart, _super);

    function Flamechart() {
      this._update = __bind(this._update, this);
      this._init = __bind(this._init, this);
      return Flamechart.__super__.constructor.apply(this, arguments);
    }

    Flamechart.version = 0.1;

    Flamechart.prototype.type = 'flamechart';

    Flamechart.prototype._init = function() {
      Flamechart.__super__._init.apply(this, arguments);
      if (this.key == null) {
        throw Error("`key()` accessor function is required for Flamechart layers");
      }
      if (this.dy == null) {
        throw Error("`dy` option is required for Flamechart layers");
      }
      if (this.y != null) {
        throw Error("`y` option cannot be defined for Flamechart layers");
      }
      this.y = (function(_this) {
        return function(d) {
          return _this.depths[_this.key(d)];
        };
      })(this);
      return this.depths = {};
    };

    Flamechart.prototype._update = function(origin) {
      var data, datum, frame, max_depth, stack, _frame, _i, _len;
      Flamechart.__super__._update.apply(this, arguments);
      data = this.current_data.slice(0);
      c3.array.sort_up(data, this.x);
      max_depth = 0;
      stack = [];
      for (_i = 0, _len = data.length; _i < _len; _i++) {
        datum = data[_i];
        frame = {
          x: this.x(datum),
          dx: this.dx(datum)
        };
        while (stack.length && frame.x >= (_frame = stack[stack.length - 1]).x + _frame.dx) {
          stack.length--;
        }
        stack.push(frame);
        max_depth = Math.max(max_depth, stack.length);
        this.depths[this.key(datum)] = stack.length - 1;
      }
      this.v.domain([0, max_depth]);
      return c3.Plot.Layer.Swimlane.prototype._update.call(this, origin);
    };

    return Flamechart;

  })(c3.Plot.Layer.Swimlane.Segment);

  c3.Plot.Layer.Swimlane.Sampled = (function(_super) {
    __extends(Sampled, _super);

    function Sampled() {
      this._sample = __bind(this._sample, this);
      this._update = __bind(this._update, this);
      this._hover_datum = __bind(this._hover_datum, this);
      return Sampled.__super__.constructor.apply(this, arguments);
    }

    Sampled.version = 0.0;

    Sampled.prototype.type = 'sampled';

    Sampled.prototype.dx = null;

    Sampled.prototype.filter = void 0;

    Sampled.prototype.safe = true;

    Sampled.prototype._hover_datum = function(x, swimlane) {
      var data, datum, idx, right;
      data = this.swimlane_data[swimlane];
      right = this.h.invert(this.h(x) + 1);
      idx = d3.bisector(this.x).right(data, x) - 1;
      if (idx < 0) {
        return [null, null];
      } else if (x < this.x(datum = data[idx]) + this.dx(datum)) {
        return [datum, idx];
      } else if (++idx < data.length && this.x(datum = data[idx]) <= right) {
        return [datum, idx];
      } else {
        return [null, null];
      }
    };

    Sampled.prototype._update = function() {
      var bottom_edge, data, datum, i, swimlane, top_edge, _i, _j, _k, _len, _len1, _ref, _ref1, _ref2, _ref3, _ref4, _results;
      Sampled.__super__._update.apply(this, arguments);
      this.swimlane_data = [];
      for (swimlane = _i = _ref = this.v.domain()[0], _ref1 = this.v.domain()[1]; _ref <= _ref1 ? _i < _ref1 : _i > _ref1; swimlane = _ref <= _ref1 ? ++_i : --_i) {
        this.swimlane_data[swimlane] = [];
      }
      _ref2 = this.v.domain(), top_edge = _ref2[0], bottom_edge = _ref2[1];
      _ref3 = this.data;
      for (i = _j = 0, _len = _ref3.length; _j < _len; i = ++_j) {
        datum = _ref3[i];
        if (!((this.filter == null) || this.filter(datum, i))) {
          continue;
        }
        swimlane = this.y(datum, i);
        if ((top_edge <= swimlane && swimlane < bottom_edge)) {
          this.swimlane_data[swimlane].push(datum);
        }
      }
      if (this.safe) {
        _ref4 = this.swimlane_data;
        _results = [];
        for (_k = 0, _len1 = _ref4.length; _k < _len1; _k++) {
          data = _ref4[_k];
          _results.push(c3.array.sort_up(data, this.x));
        }
        return _results;
      }
    };

    Sampled.prototype._sample = function(sample) {
      var bisector, data, datum, datum_x, idx, pixel, prev_idx, swimlane, v, x, _i, _ref, _ref1;
      bisector = d3.bisector(this.x).right;
      for (swimlane = _i = _ref = this.v.domain()[0], _ref1 = this.v.domain()[1]; _ref <= _ref1 ? _i < _ref1 : _i > _ref1; swimlane = _ref <= _ref1 ? ++_i : --_i) {
        v = this._v(swimlane);
        data = this.swimlane_data[swimlane];
        if (!data.length) {
          continue;
        }
        prev_idx = bisector(data, this.h.domain()[0]);
        if (!prev_idx) {
          pixel = Math.round(this.h(this.x(this.data[prev_idx])));
        } else {
          prev_idx--;
          pixel = this.h(this.x(this.data[prev_idx]) + this.dx(this.data[prev_idx])) > 0 ? 0 : Math.round(this.h(this.x(data[prev_idx])));
        }
        while (pixel < this.width) {
          x = this.h.invert(pixel);
          idx = prev_idx;
          while (idx < data.length) {
            datum = data[idx];
            prev_idx = idx;
            if ((datum_x = this.x(datum)) > x) {
              pixel = Math.round(this.h(datum_x));
              break;
            }
            if (x <= datum_x + this.dx(datum)) {
              break;
            }
            idx++;
          }
          if (idx === data.length) {
            break;
          }
          sample(pixel, v, datum);
          pixel++;
        }
      }
    };

    return Sampled;

  })(c3.Plot.Layer.Swimlane);

  c3.Plot.Layer.Swimlane.Sampled.SVG = (function(_super) {
    __extends(SVG, _super);

    function SVG() {
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      return SVG.__super__.constructor.apply(this, arguments);
    }

    SVG.version = 0.0;

    SVG.prototype.type = 'svg';

    SVG.prototype.line_options = void 0;

    SVG.prototype._draw = function(origin) {
      var current_data, pixels;
      SVG.__super__._draw.apply(this, arguments);
      current_data = [];
      pixels = [];
      this._sample(function(x, y, datum) {
        current_data.push(datum);
        return pixels.push({
          x: x,
          y: y
        });
      });
      this.lines = c3.select(this.g, 'line').options(this.line_options).bind(current_data).update();
      return this.lines.position({
        x1: function(d, i) {
          return pixels[i].x + 0.5;
        },
        x2: function(d, i) {
          return pixels[i].x + 0.5;
        },
        y1: this.y == null ? 0 : function(d, i) {
          return pixels[i].y - 0.5;
        },
        y2: this.y == null ? this.height : (function(_this) {
          return function(d, i) {
            return pixels[i].y + _this.dy - 0.5;
          };
        })(this)
      });
    };

    SVG.prototype._style = function() {
      SVG.__super__._style.apply(this, arguments);
      return this.lines.style();
    };

    return SVG;

  })(c3.Plot.Layer.Swimlane.Sampled);

  c3.Plot.Layer.Swimlane.Sampled.Canvas = (function(_super) {
    __extends(Canvas, _super);

    function Canvas() {
      this.zoom = __bind(this.zoom, this);
      this._style = __bind(this._style, this);
      this._draw = __bind(this._draw, this);
      this.__draw = __bind(this.__draw, this);
      this._size = __bind(this._size, this);
      this._init = __bind(this._init, this);
      return Canvas.__super__.constructor.apply(this, arguments);
    }

    Canvas.version = 0.0;

    Canvas.prototype.type = 'canvas';

    Canvas.prototype.line_options = void 0;

    Canvas.prototype._init = function() {
      var foreignObject;
      Canvas.__super__._init.apply(this, arguments);
      foreignObject = c3.select(this.g, 'foreignObject').singleton().position({
        height: '100%',
        width: '100%'
      });
      return this.canvas = foreignObject.select('xhtml|canvas').singleton();
    };

    Canvas.prototype._size = function() {
      Canvas.__super__._size.apply(this, arguments);
      return this.canvas.position({
        height: this.height,
        width: this.width
      });
    };

    Canvas.prototype.__draw = function() {
      var context, stroke, _ref, _ref1;
      context = this.canvas.node().getContext('2d');
      context.clearRect(0, 0, this.width, this.height);
      context.translate(0.5, 0.5);
      stroke = c3.functor((_ref = this.line_options) != null ? (_ref1 = _ref.styles) != null ? _ref1.stroke : void 0 : void 0);
      this._sample((function(_this) {
        return function(x, y, datum) {
          context.beginPath();
          context.moveTo(x, y);
          context.lineTo(x, y + _this.dy);
          context.strokeStyle = stroke(datum);
          return context.stroke();
        };
      })(this));
      return context.translate(-0.5, -0.5);
    };

    Canvas.prototype._draw = function(origin) {
      Canvas.__super__._draw.apply(this, arguments);
      return this.__draw(origin);
    };

    Canvas.prototype._style = function(style_new) {
      Canvas.__super__._style.apply(this, arguments);
      if (!style_new) {
        return this.__draw('restyle');
      }
    };

    Canvas.prototype.zoom = function() {
      return this.__draw('zoom');
    };

    return Canvas;

  })(c3.Plot.Layer.Swimlane.Sampled);

}).call(this);
